<document type=media style=black>
%%with-pdf
<c><p align=right><a href=@talk-mt-08.html>present</a>
/ <a href=mt-08.pdf>print</a>
</p></c>
:@- (intelligent) multimedia technology -- 2008
<c>
<h5 align=right><red>
<b><a href=http://www.cs.vu.nl/~eliens/create/present-challenge.html>challenge(s)</a> / <a href=http://www.cs.vu.nl/~eliens/create/inspire-mt.html><red>inspiration(s)</red></a> / <a href=http://www.cs.vu.nl/~eliens/create/inspire-picnic.html>picnic(s)</a> / <a href=resource-mt.html><red>resource(s)</red></a> / <a href=intro-imt-07.html>imt 07</a></b>
</red></h5></c>
<slide id=imt-08-opz>
/// <a href=http://www.cs.vu.nl/~eliens/media><em>everything you always wanted to program but never ...</em></a>
:@ (I)MT 2008 -- <a href=opzet.html>new course topics</a>
<br>
\noindent
The course will be of a practical nature, encouraging the students
to produce appealing applications,
such as <b>rich-media mashups</b>, <b>data-driven visualisation(s)</b>
and to experiment with
<b>new (media) technologies</b>.
<l>
/// A. Eliens, october 2008, (eliens@cs.vu.nl)
</l>
<c>
<p>
\noindent
contact //mailto:eliens@cs.vu.nl
for more information.
</c>
<navigate/>
</slide>

:@ theme(s) -- web services, visualisation, (multimodal) interaction(s)
<br>
\noindent
An ongoing theme for <b>multimedia @ VU</b> is (serious) games.
Web services, and visualisation(s) of on going activities,
may contribute to authoring such games, by allowing for live/dynamic
content.
<slide color=black id=imt-08-themes>
<c>
/// theme(s) -- web services, visualisation, (multimodal) interaction(s)
</c>
<small>
<ul>
<li> <a href=http://www.cs.vu.nl/~eliens/projects/project-climate.html>climate game(s)</a>
<li> <a href=http://www.cs.vu.nl/~eliens/projects/project-china.html>language game(s)</a>
<li> <a href=http://www.cs.vu.nl/~eliens/projects/project-community.html>social network(s)</a>
</ul>
</small>
<navigate/>
</slide>
\noindent
Also social network technologies are of interest, not only as 
a source of dynamic content, but also for aspects of (real time)
communication, among others to promote a sense of being connected.

:@ inspiration(s) -- (serious) mashups
<br>
\noindent
Both the <b>social web</b> and the <b>instance web</b>,
as exemplified in <b>twitter</b> messages, may result in
intersting patterns of behavior.
One of the challenge(s) here is to visualize these patterns.
<so inspire-mt-08>
\noindent
Visualizations may intent to be nothing but pleasing or artful, but
may potentially also lead to a better understanding of human
behavior, as advocated in a discpline known as
<b><url href=http://www.hpcwire.com/features/The_Next_Big_Thing_in_Humanities_Arts_and_Social_Science_Computing_Cultural_Analytics.html>Cultural Analytics</url></b>. 


:@ assignment(s)
<br>
\noindent
There is considerable freedom in the choice of your project(s),
however it must comply with the theme
of <b>rich media (data-driven) mashup(s)</b>, and (in principle)
make use of <b>recommended technologies</b>,
among which the <b>flex/as3</b> framework.
<slide id=mt-08-assignment> 
/// assignment(s)
<small>
<ul>
<li> see <a href=practicum.html>practicum</a>
-- rich media (data-driven) mashup(s)
</ul>
</small>
<navigate/>
</slide>
\noindent
In delivering the project result, you must strive for
a professional approach, that is an end product, downloadable as zip,
with all sources, working examples, documentation as well
as tutorial or getting started applications, that illustrate
your project.

:@ resource(s) -- recommended technology
<br>
\noindent
You are strongly encouraged to develop <b>rich-media mashup(s)</b> in the <b>flex/as3</b>
framework, with (possibly) use of <b>PHP</b>, for server-side
extensions, needed to circumvent security restrictions,
using <b>XML</b> and/or <b>AMF</b> (Actionscript Message Format) for exchange.
<so resource-mt>
\noindent
Alternatively, however, you may focus on <b>server-side mashups</b>, with a suitable <b>rich-media interface</b>, preferably availabe
as a flex component.

:@ lookat(s) -- example application(s)
<br>
\noindent
To get familiar with the various technologies,
kearning by example seems by far the most efficient method.
After looking at the examples, get some practical experience,
and then decide on the goals and requirements of 
your project.
<so lookat-mt>
\noindent
Obvoiously, one of the major challenges here is to circumvent
security restrictions of the flash player and connect to
servers outside of the domain of origin.
As in the last examples, you need a proxy, that you may
download from <url href=http://www.cs.vu.nl/~eliens/media/proxy.zip>media/proxy.zip</url>. By the way, do not hesitate to look at <url href=http://labs.adobe.com/technologies/flashplayer10>flashplayer 10</url>.

<so resource-deliverable>

<slide color=black id=mt-08-scope>
:@ scope(s) -- <a href=http://www.cs.vu.nl/~eliens/create/@slide-artist-quote.html>aspiration(s)</a>
<br>
\noindent
Although it is tempting to develop the <b>ultimate application</b>,
that will make you rich and famous for the rest of your life,
there are great <b>risk(s)</b>, that you will not succeed,
and as a consequence end up with <b>nothing</b> useful. 
Develop a <b>prototype</b>, is my advice, that runs on <b>localhost</b> and
may be used later, perhaps by yourself, to realize the 
system that ultimately fullfills your <b>dream(s)</b> ...
Another advice, why not do the obvious, and use <b>map(s)</b>?
<navigate/>
</slide>

<c>
:@ etcetera(s)
<ul>
<li> 3d chat -- http://dev.getoutsmart.com/os3d/demos/videoroom 
<li> RIA -- http://www.getoutsmart.com/rich-internet-applications.htm
<li> web 2.0 vs virtual worlds -- http://blog.getoutsmart.com/archives/category/the-internet
</ul>
</c>

</document>
