<document>
:@* Multimedia Authoring II -- virtual environments

with a focus on programming intelligent agents
in virtual environments

:@ Objectives
<p>

By the end of the course students will have  been introduced to the ideas of
virtual communities, and will
have a working knowledge of distributed logic programming language (DLP),
especially a knowledge on
the development and implementation of intelligent avatars for virtual
environments and E-commerce.

@ Prerequisites
<p>

Essential:  Virtual Reality Modeling Language (VRML).

@ Approach

The main focus will be on the practical work of the students. They will have
to make a number of assignments and give a presentation at the end of the
course.

@ Course structure

<ol>
<li> Introduction -- principles and applications of distributed logic
programming language for virtual environments. Concepts: avatar, intelligent
avatar, agent, web agent, logic programming, distributed
logic programming

<li> DLP for virtual environments I-- VRML EAI, DLP and its EAI libraries.
Examples: bus driving and ball kicking.

<li> DLP for virtual environments II -- multiple thread controls, cognitive
models of intelligent avatars.
<br>
Examples: WASP soccer games

<li> Avatar Design --  H-anim, specification for a standard humanoid, Blaxxun
avatar studio. Using DLP to control the gestures of avatars.
Examples: soccer player avatars and presentation avatars

<li> Virtual communities -- Blaxxun virtual communities, DLP for virtual
communities. Examples: multiple users of WASP soccer games.
</ol>

:@ Material

Due to the lack of suitable, up-to-date, material, we will develop our own
syllabus

@ Recommended additional reading

<ul>
<li> [1] Anton Eliens,  DLP, A language for distributed logic programming, Wiley,
1992.

<li> [2] Zhisheng Huang,  Anton Eliens, Cees Visser,  Progammability of
intelligent agent avatars,
     Research report, Department of computer science, Vrije university,
2001.

<li> [3] Watson, M.,  AI Agents in Virtual Reality Worlds -- programming
intelligent VR in C++, Wiley, 1996.
</ul>
</document>
