<document>

:@* Persuasive Technology


<slide id=pers-0>
<h4 align=right>persuasion</h4>
<p>
<ul>
<li>is a communication process in which the communicator seeks to elicit  a desired response from his receiver</li>
<li>is a conscious attempt by one individual to change the attitudes, beliefs or behaviours of another individual or group individual through the transmission of some messages.</li>
</ul>
</slide>

<slide id=pers-1>
<p>
The purpose of persuasion is to accomplish one of the following goals: to induce the audience to take some action, to educate the audience (persuade them to accept to accept information or data), or to provide the audience with an  experience. Tyler A.
</slide>

<slide id=pers-2>
<p>
In Interactive media, the field of application ranges from E-commerce, social marketing (like AIDS campaign) to museum exhibits. E-commerce is an obvious example. To convince people to buy more, more persuasive messages and technologies are developed through the use of humorous and emotional communication, agents (such as price finders) or 3D representations of products and shops. For health campaigns (or any of your choice), one can imagine, 3D information spaces with agents presenting different point of views and where users are given different roles to play. In a museum you might want to highlight key points through innovative and fun interactive exhibits.
</slide>
<slide color=red id=pers-3>
<p>
The art of persuasion is to find innovative design perspectives and technologies adapted to the audience and communication objectives.
</slide>

<slide id=pers-4>
<h4>References</h4>
<p>
<ul>
<li>http://www.captology.org    Persuasive technology, Stanford University </li>

<li>http://mindlab.msu.edu/networkedminds/exp3d/index.htm  EXPERIENTIAL E-COMMERCE:
3-D Visualizations, Product Simulations, Embodied Agents and Virtual Environments  Conference </li>
<li> this works -- http://www.mindlab.msu.edu/mweb/research/publications/ecommerce.pdf </li>
<li>http://www.social-marketing.org/index.html   Social Marketing </li>

<li>King P. Tester J. (1999) The landscape of persuasive technologies. Communication of the ACM, vol 42, 5 31-38 </li>

<li>Khaalavsky J. and Shedroff N. (1999)  Understanding the seductive experience. Communication of the ACM vol 42, 45-49 </li>
</ul>
</slide>


</document>
