%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;

#include <hush/sys/unistd.h>
#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <iostream.h>

#define out if (pr) cout

static char name[64];
static int slino = 0;

void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	cout << "## DEPRECATED " << s << endl; 
	}

static int nl = 0;
static int nx = 0;
%}
name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C \@
%%@ rules

^"%%".* { }
^[a-zA-Z]+":".* { }
^[a-z0-9A-Z]+"=" { cout << yytext << "\""; nl=1; }
^[a-z0-9A-Z]+"=\"" { cout << yytext; }
"project=true" { cout << "project();"; }
\_[0-9A-Za-z] { cout << yytext+1; }
^"<br>x"[a-zA-Z]+":".* { }
^"<br>subject=" { cout << yytext+4 << "\""; nl=1; }
^"<br>number=".* {}
"<br>relevantie=" { cout << yytext+4 << "\""; nl=1; }
"<br>inhoud=" { cout << yytext+4 << "\""; nl=1; }
"<br>presentatie=" { cout << yytext+4 << "\""; nl=1; }
"<br>begeleiding=" { cout << yytext+4 << "\""; nl=1; }
"<br>practicum=" { cout << yytext+4 << "\""; nl=1; }
^"<br>topic=" { cout << yytext+4 << "\""; nl=1; }
^"<br>relevance=" { cout << yytext+4 << "\""; nl=1; }
^"<br>student=" { cout << yytext+4 << "\""; nl=1; }
^"<br>email=" { cout << yytext+4 << "\""; nl=1; }
^"<br>applications=" { cout << yytext+4 << "\""; nl=0; nx=1; }
^"<br>supervision=" { cout << yytext+4 << "\""; nl=0; nx=1; }
^"<br>tools=" { cout << "\";" << endl; cout << yytext+4 << "\""; nl=0; nx=1; }
^"<br>technologies=" { cout << "\";" << endl; cout << yytext+4 << "\""; nl=0; nx=1; }
"<br>remarks=" { cout << yytext+4 << "\""; nl=0; nx=1; }
^"<br>x"[a-z0-9A-Z]+"=\"" { cout << yytext+4; }
"<br>project=true" { cout << "\";" << endl;  cout << "project();"; nx=0; }
[\ ]*\n {
if (nl) { cout << "\";" << endl; nl=0; } 
else if (nx) { cout << "\" +" << endl; cout <<  "\"<br>"; }  
else cout << endl; 
}
. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
//align = "BEGIN";
strcpy(name,"temp");
int _argc = 0;
cerr << "ARGC " << argc << endl;
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N' ) {
	strcpy(name,argv[0]+2);
	} else if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
        cerr << "ARGC " << argc << endl;
	argc--; argv++;
	}

cerr << "ARGC " << argc << endl;
l.paths(_argc, _argv);
pr = 1;
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
return 0;
}
//</>
