<document>
:@* selfstudy IMT

You are adviced to get familiar with DLP by installing it on your machine,
and by looking at the examples (see technical information below).
For final grading you have to make two assignments, and write a
brief report  specifying how you used DLP
in combination with VRML (or other 3D) technology in your assignments.
For those interested, there is the possibility to explore DLP/AMICO
in the context of Delta3D game engine.

:@ assignment(s)
<ol>
<li> write a simple physics system (e.g. bouncing balls) with control
from DLP (e.g. collision detection)
<li> write a game of your choice, and specify the game logic (and
possibly visual effects) in DLP.
<li> write a 3-5 page report, specifying how <em>intelligent 
multimedia technology</em> was used in your application(s).
</ol>

:@ procedure
Get familiar with the technology and develop an application 
for assignment 1. Keep this simple and transparant.
Submit a synopsis for assignment 2. You may want to talk this over.
In that case make an appointment with any of the supervisors.
For grading, you must submit your paper (that is make it available on your site) and make an appointment for demonstrating your application(s).

:@ co-supervision
<ul>
<li> Zeljko Obrenovic -- (<a href=http://homepages.cwi.nl/~obrenovi>information</a>) -- //mailto:Zeljko.Obrenovic@cwi.nl 
</ul>


:@ technical information
<ul>
<li> getting started: <a href=http://dlp.cs.vu.nl/~ctv/dlpinfo/docs/readme.html>Release Notes DLP</a>
<li> examples: <a href=http://dlp.cs.vu.nl/~ctv/dlpinfo/vrml/index.html>DLP+VRML</a>
<li> [optional] AMICO: <a href=http://dlp.cs.vu.nl/~ctv/amico/docs/html/index.html>Ambient Intelligence Communicator</a>
<li> (optional) Delta3D <a href=http://www.delta3d.org>open source game engine</a>
</ul>




:@ course material
<ul>
<li> <a href=local/course/index.htm> lecture notes MMA2/IMT </a>
<li> <a href=local/material/imt.pdf>syllabus</a>
<li> <a href=local/material/ppt>slides</a>
<li> <a href=local/material/exercise>exercises</a>
</ul>
</document>
